#include once "png.bi"
#include once "fbgfx.bi"


sub save_png(img as FB.IMAGE ptr, file as string)
	dim fp as FILE ptr
	fp = fopen(strptr(file), @"wb")

	dim as png_structp png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL)
	dim as png_infop info_ptr = png_create_info_struct(png_ptr)
	
	if (setjmp(png_jmpbuf(png_ptr))) then
		print "error in save_png"
		return
	EndIf
	
	png_init_io(png_ptr, fp)
	
	png_set_IHDR(png_ptr, info_ptr, img->width, img->height, 1, PNG_COLOR_TYPE_GRAY, PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT)
	png_write_info(png_ptr, info_ptr)
	
	dim as png_bytep row = Allocate(img->width \ 8)
	dim as ubyte ptr pp '= cptr(ubyte ptr, img+1)
	dim as integer bypp '= img->bpp
	ImageInfo(img, /'w'/,/'h'/, bypp,/'pitch'/, pp)
	if bypp <> 1 then
		print "error: only 1bypp images supported"
		return
	EndIf
	for y as integer = 0 to img->height-1
		for x as integer = 0 to img->width-1
			dim off as integer = x mod 8
			dim idx as integer = x \ 8
			if off = 0 then row[idx] = 0
			if *(pp+y*img->pitch+x) <> 0 then
				row[idx] or= (&b10000000 shr off)
			EndIf
		Next
		png_write_row(png_ptr, row)
	Next
	png_write_end(png_ptr, NULL)
	
	if (fp <> NULL) then fclose(fp)
	if (info_ptr <> NULL) then png_free_data(png_ptr, info_ptr, PNG_FREE_ALL, -1)
	if (png_ptr <> NULL) then png_destroy_write_struct(@png_ptr, NULL)
	if (row <> NULL) then DeAllocate(row)

End sub



screenres 200, 200, 1
palette 0, &H000000
palette 1, &HFFFFFF
'palette 0, 0,0,0
'palette 1, 255,255,255

line (0,0)-(199,199), 1, BF
circle (100,100), 50, 0, ,,,F
line (0,0)-(199,199), 0
line (0,199)-(199,0), 0
for q as integer = 0 to 50: line (0,0)-(rnd*100, rnd*100), 0: next

dim img as FB.IMAGE ptr
img = ImageCreate(200, 200,,1)
get (0,0)-(199,199), img

print img->width
print img->height
print img->bpp
print img->pitch

save_png(img, "test.png")



sleep
