#include once "png.bi"
#include once "fbgfx.bi"


sub save_png(img as FB.IMAGE ptr, file as string)
	dim fp as FILE ptr
	fp = fopen(strptr(file), @"wb")

	dim as png_structp png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL)
	dim as png_infop info_ptr = png_create_info_struct(png_ptr)
	
	if (setjmp(png_jmpbuf(png_ptr))) then
		print "error in save_png"
		return
	EndIf
	
	png_init_io(png_ptr, fp)
	
	png_set_IHDR(png_ptr, info_ptr, img->width, img->height, 8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT)
	png_write_info(png_ptr, info_ptr)
	
	dim as png_bytep row = Allocate(3 * img->width * sizeof(png_byte))
	dim as ubyte ptr pp '= cptr(ubyte ptr, img+1)
	dim as integer bypp '= img->bpp
	ImageInfo(img, /'w'/,/'h'/, bypp,/'pitch'/, pp)
	if bypp <> 4 then
		print "error: only 4bypp images supported"
		return
	EndIf
	for y as integer = 0 to img->height-1
		for x as integer = 0 to img->width-1
			row[x*3  ] = *(pp+y*img->pitch+x*bypp+2)
			row[x*3+1] = *(pp+y*img->pitch+x*bypp+1)
			row[x*3+2] = *(pp+y*img->pitch+x*bypp)
		Next
		'ImageConvertRow(pp+(img->pitch)*y, img->bpp, row, 24, img->width)
		png_write_row(png_ptr, row)
	Next
  png_write_end(png_ptr, NULL)
	
	if (fp <> NULL) then fclose(fp)
	if (info_ptr <> NULL) then png_free_data(png_ptr, info_ptr, PNG_FREE_ALL, -1)
	if (png_ptr <> NULL) then png_destroy_write_struct(@png_ptr, NULL)
	if (row <> NULL) then DeAllocate(row)

End sub



screenres 300, 300, 32

line (1,1)-(200,200), &H0000FF, BF
circle (100,100), 50, &HFF0000, ,,,F
line (1,1)-(200,200), &H00FF00
line (1,200)-(200,1), &H00FF00
for q as integer = 0 to 500: line (1,1)-(rnd*100, rnd*100), rnd*&HFFFFFF: next

dim img as FB.IMAGE ptr
img = ImageCreate(200, 200,,32)
get (1,1)-(200,200), img

'print img->width
'print img->height
'print img->bpp
'print img->pitch

save_png(img, "test.png")



sleep
